Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.io
Interface ReadBuffer.BufferInput

All Superinterfaces:
  java.io.DataInput, InputStreaming

All Known Implementing Classes:
  AbstractByteArrayReadBuffer.ByteArrayBufferInput, AbstractReadBuffer.AbstractBufferInput, ByteBufferReadBuffer.ByteBufferInput, MultiBufferReadBuffer.MultiBufferInput, WrapperBufferInput

Enclosing interface:
  ReadBuffer

      public static interface ReadBuffer.BufferInput

extends InputStreaming, java.io.DataInput

The BufferInput interface represents a DataInputStream on top of a ReadBuffer.

Author:
  cp 2005.01.18

Method Summary
`int` | `available()` Returns the number of bytes that can be read (or skipped over) from this input stream without causing a blocking I/O condition to occur.
`void` | `close()` Close the InputStream and release any system resources associated with it.
`ReadBuffer` | `getBuffer()` Get the ReadBuffer object that this BufferInput is reading from.
`int` | `getOffset()` Determine the current offset of this BufferInput within the underlying ReadBuffer.
`void` | `mark(int cbReadLimit)` Marks the current read position in the InputStream in order to support the stream to be later "rewound" (using the `InputStreaming.reset()` method) to the current position.
`boolean` | `markSupported()` Determine if this InputStream supports the `mark(int)` and `InputStreaming.reset()` methods.
`boolean` | `readBoolean()` Read a boolean value.
`ReadBuffer` | `readBuffer(int cb)` Read `cb` bytes and return them as a ReadBuffer object.
`byte` | `readByte()` Read a byte value.
`char` | `readChar()` Read a char value.
`double` | `readDouble()` Read a double value.
`float` | `readFloat()` Read a float value.
`void` | `readFully(byte[] ab)` Read `ab.length` bytes and store them in `ab`.
`void` | `readFully(byte[] ab, int of, int cb)` Read `cb` bytes and store them in `ab` starting at offset `of`.
`int` | `readInt()` Read an int value.
`java.lang.String` | `readLine()` Reads the next "line" of text.
`long` | `readLong()` Read a long value.
`int` | `readPackedInt()` Read an int value using a variable-length storage format as described by `WriteBuffer.BufferOutput.writePackedInt(int)`.
`long` | `readPackedLong()` Read a long value using a variable-length storage format as described by `WriteBuffer.BufferOutput.writePackedLong(long)`.
`java.lang.String` | `readSafeUTF()` Read a variable-length encoded UTF packed String.
`short` | `readShort()` Read a short value.
`int` | `readUnsignedByte()` Read an unsigned byte value.
`int` | `readUnsignedShort()` Read an unsigned short value.
`java.lang.String` | `readUTF()` Reads a String value.
`void` | `setOffset(int of)` Specify the offset of the next byte to read from the underlying ReadBuffer.
`int` | `skipBytes(int cb)` Skips over up to the specified number of bytes of data.

Methods inherited from interface com.tangosol.io.InputStreaming
`read, read, read, reset, skip`

Method Detail

### available

    int available()
                  throws java.io.IOException

  Returns the number of bytes that can be read (or skipped over) from this input stream without causing a blocking I/O condition to occur. This method reflects the assumed implementation of various buffering InputStreams, which can guarantee non-blocking reads up to the extent of their buffers, but beyond that the read operations will have to read from some underlying (and potentially blocking) source.

  BufferInput implementations must implement this method to return the extent of the buffer that has not yet been read; in other words, the entire un-read portion of the buffer must be available.

  Specified by:
    `available` in interface `InputStreaming`
  Returns:
    the number of bytes that can be read from this InputStream without blocking
  Throws:
    `java.io.IOException` - if an I/O error occurs

### close

    void close()
               throws java.io.IOException

  Close the InputStream and release any system resources associated with it.

  BufferInput implementations do not pass this call down onto an underlying stream, if any.

  Specified by:
    `close` in interface `InputStreaming`
  Throws:
    `java.io.IOException` - if an I/O error occurs

### mark

    void mark(int cbReadLimit)

  Marks the current read position in the InputStream in order to support the stream to be later "rewound" (using the `InputStreaming.reset()` method) to the current position. The caller passes in the maximum number of bytes that it expects to read before calling the `InputStreaming.reset()` method, thus indicating the upper bounds of the responsibility of the stream to be able to buffer what it has read in order to support this functionality.

  BufferInput implementations ignore the `cbReadLimit`; they must support an unlimited read limit, since they appear to the user as an input stream on top of a fully realized read buffer.

  Specified by:
    `mark` in interface `InputStreaming`
  Parameters:
    `cbReadLimit` - the maximum number of bytes that caller expects the InputStream to be able to read before the mark position becomes invalid

### markSupported

    boolean markSupported()

  Determine if this InputStream supports the `mark(int)` and `InputStreaming.reset()` methods.

  BufferInput implementations must support the `mark(int)` and `InputStreaming.reset()` methods, so this method always returns `true`.

  Specified by:
    `markSupported` in interface `InputStreaming`
  Returns:
    `true` if this InputStream supports the mark and reset method; `false` otherwise

### readFully

    void readFully(byte[] ab)
                   throws java.io.IOException

  Read `ab.length` bytes and store them in `ab`.

  This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Specified by:
    `readFully` in interface `java.io.DataInput`
  Parameters:
    `ab` - the array to store the bytes which are read from the stream
  Throws:
    `java.lang.NullPointerException` - if the passed array is null
    `java.io.EOFException` - if the stream is exhausted before the number of bytes indicated by the array length could be read
    `java.io.IOException` - if an I/O error occurs

### readFully

    void readFully(byte[] ab,
                   int of,
                   int cb)
                   throws java.io.IOException

  Read `cb` bytes and store them in `ab` starting at offset `of`.

  This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Specified by:
    `readFully` in interface `java.io.DataInput`
  Parameters:
    `ab` - the array to store the bytes which are read from the stream
    `of` - the offset into the array that the read bytes will be stored
    `cb` - the maximum number of bytes to read
  Throws:
    `java.lang.NullPointerException` - if the passed array is null
    `java.lang.IndexOutOfBoundsException` - if `of` or `cb` is negative, or `of+cb` is greater than the length of the `ab`
    `java.io.EOFException` - if the stream is exhausted before the number of bytes indicated by the array length could be read
    `java.io.IOException` - if an I/O error occurs

### skipBytes

    int skipBytes(int cb)
                  throws java.io.IOException

  Skips over up to the specified number of bytes of data. The number of bytes actually skipped over may be fewer than the number specified to skip, and may even be zero; this can be caused by an end-of-file condition, but can also occur even when there is data remaining to be read. As a result, the caller should check the return value from this method, which indicates the actual number of bytes skipped.
  Specified by:
    `skipBytes` in interface `java.io.DataInput`
  Parameters:
    `cb` - the maximum number of bytes to skip over
  Returns:
    the actual number of bytes that were skipped over
  Throws:
    `java.io.IOException` - if an I/O error occurs

### readBoolean

    boolean readBoolean()
                        throws java.io.IOException

  Read a boolean value.

  This method is the counterpart for the `DataOutput.writeBoolean(boolean)` method.

  Specified by:
    `readBoolean` in interface `java.io.DataInput`
  Returns:
    either `true` or `false`
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readByte

    byte readByte()
                  throws java.io.IOException

  Read a byte value.

  This method is the counterpart for the `DataOutput.writeByte(int)` method.

  Specified by:
    `readByte` in interface `java.io.DataInput`
  Returns:
    a `byte` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readUnsignedByte

    int readUnsignedByte()
                         throws java.io.IOException

  Read an unsigned byte value.

  This method is the counterpart for the `DataOutput.writeByte(int)` method when it is used with unsigned 8-bit values.

  Specified by:
    `readUnsignedByte` in interface `java.io.DataInput`
  Returns:
    an `int` value in the range 0x00 to 0xFF
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readShort

    short readShort()
                    throws java.io.IOException

  Read a short value.

  This method is the counterpart for the `DataOutput.writeShort(int)` method.

  Specified by:
    `readShort` in interface `java.io.DataInput`
  Returns:
    a `short` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readUnsignedShort

    int readUnsignedShort()
                          throws java.io.IOException

  Read an unsigned short value.

  This method is the counterpart for the `DataOutput.writeShort(int)` method when it is used with unsigned 16-bit values.

  Specified by:
    `readUnsignedShort` in interface `java.io.DataInput`
  Returns:
    an `int` value in the range of 0x0000 to 0xFFFF
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readChar

    char readChar()
                  throws java.io.IOException

  Read a char value.

  This method is the counterpart for the `DataOutput.writeChar(int)` method.

  Specified by:
    `readChar` in interface `java.io.DataInput`
  Returns:
    a `char` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readInt

    int readInt()
                throws java.io.IOException

  Read an int value.

  This method is the counterpart for the `DataOutput.writeInt(int)` method.

  Specified by:
    `readInt` in interface `java.io.DataInput`
  Returns:
    an `int` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readLong

    long readLong()
                  throws java.io.IOException

  Read a long value.

  This method is the counterpart for the `DataOutput.writeLong(long)` method.

  Specified by:
    `readLong` in interface `java.io.DataInput`
  Returns:
    a `long` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readFloat

    float readFloat()
                    throws java.io.IOException

  Read a float value.

  This method is the counterpart for the `DataOutput.writeFloat(float)` method.

  Specified by:
    `readFloat` in interface `java.io.DataInput`
  Returns:
    a `float` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readDouble

    double readDouble()
                      throws java.io.IOException

  Read a double value.

  This method is the counterpart for the `DataOutput.writeDouble(double)` method.

  Specified by:
    `readDouble` in interface `java.io.DataInput`
  Returns:
    a `double` value
  Throws:
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### readLine

    java.lang.String readLine()
                              throws java.io.IOException

  Reads the next "line" of text.

  This method does not have a counterpart in the `DataOutput` interface. Furthermore, this method is defined as operating on bytes and not on characters, and thus it should be selected for use only after careful consideration, as if it were deprecated (which it has been in java.io.DataInputStream).

  Specified by:
    `readLine` in interface `java.io.DataInput`
  Returns:
    a line of text as a String
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### readUTF

    java.lang.String readUTF()
                             throws java.io.IOException

  Reads a String value.

  This method is the counterpart for the `DataOutput.writeUTF(java.lang.String)` method.

  Specified by:
    `readUTF` in interface `java.io.DataInput`
  Returns:
    a String value
  Throws:
    `java.io.UTFDataFormatException` - if the bytes that were read were not a valid UTF-8 encoded string
    `java.io.EOFException` - if the value could not be read because no more data remains to be read
    `java.io.IOException` - if an I/O error occurs

### getBuffer

    ReadBuffer getBuffer()

  Get the ReadBuffer object that this BufferInput is reading from.
  Returns:
    the underlying ReadBuffer object

### readSafeUTF

    java.lang.String readSafeUTF()
                                 throws java.io.IOException

  Read a variable-length encoded UTF packed String. The major differences between this implementation and DataInput is that this supports null String values and is not limited to 64KB UTF-encoded values.
  Returns:
    a String value; may be null
  Throws:
    `java.io.IOException` - if an I/O error occurs

### readPackedInt

    int readPackedInt()
                      throws java.io.IOException

  Read an int value using a variable-length storage format as described by `WriteBuffer.BufferOutput.writePackedInt(int)`.
  Returns:
    an int value
  Throws:
    `java.io.IOException` - if an I/O error occurs

### readPackedLong

    long readPackedLong()
                        throws java.io.IOException

  Read a long value using a variable-length storage format as described by `WriteBuffer.BufferOutput.writePackedLong(long)`.
  Returns:
    a long value
  Throws:
    `java.io.IOException` - if an I/O error occurs

### readBuffer

    ReadBuffer readBuffer(int cb)
                          throws java.io.IOException

  Read `cb` bytes and return them as a ReadBuffer object.
  Parameters:
    `cb` - the number of bytes to read
  Returns:
    a ReadBuffer object composed of `cb` bytes read from the BufferInput
  Throws:
    `java.io.EOFException` - if the stream is exhausted before the number of bytes indicated could be read
    `java.io.IOException` - if an I/O error occurs

### getOffset

    int getOffset()

  Determine the current offset of this BufferInput within the underlying ReadBuffer.
  Returns:
    the offset of the next byte to read from the ReadBuffer

### setOffset

    void setOffset(int of)

  Specify the offset of the next byte to read from the underlying ReadBuffer.
  Parameters:
    `of` - the offset of the next byte to read from the ReadBuffer
  Throws:
    `java.lang.IndexOutOfBoundsException` - if `of < 0` or `of > getBuffer().length()`

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.